=== debian/changelog ===
ceres-solver (1.12.0+dfsg0-1) unstable; urgency=medium

  * New upstream version 1.12.0

 -- Philipp Huebner <debalance@debian.org>  Mon, 05 Dec 2016 21:40:28 +0100
