## ceres-solver 1.13.0~rc1~dfsg0

=== debian/changelog ===
ceres-solver (1.13.0~rc1~dfsg0-1) unstable; urgency=medium

  * New upstream version 1.13.0~rc1~dfsg0
  * Re-add README.source
  * Updated Standards-Version: 4.0.0 (no changes needed)
  * Updated years in debian/copyright
  * Move usr/lib/cmake/ceres -> usr/lib/cmake/Ceres (LP: 1678043)
  * Add patch from upstream commit to fix failing unit test

 -- Philipp Huebner <debalance@debian.org>  Fri, 28 Jul 2017 11:02:15 +0200
