=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                python-sphinx,
                python-sphinx-rtd-theme,
                libjs-mathjax
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/ceres-solver.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ceres-solver.git
 Homepage: http://ceres-solver.org
