=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,8 @@
 		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
 		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
 		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
-		-DBUILD_DOCUMENTATION=OFF
+		-DBUILD_DOCUMENTATION=OFF \
+		-DCMAKE_BUILD_TYPE=Release
 	dh_auto_build --parallel
 	dh_auto_test --parallel
 	mv -v ${CURDIR}/obj-*/lib/libceres.a ${CURDIR}/debian/
@@ -32,7 +33,8 @@
 		-DSUITESPARSE_INCLUDE_DIR_HINTS=/usr/include/suitesparse/ \
 		-DCXSPARSE_LIBRARY_DIR_HINTS=/usr/lib/${DEB_HOST_MULTIARCH}/ \
 		-DCXSPARSE_INCLUDE_DIR=/usr/include/suitesparse/ \
-		-DBUILD_DOCUMENTATION=ON
+		-DBUILD_DOCUMENTATION=ON \
+		-DCMAKE_BUILD_TYPE=Release
 	dh_auto_build --parallel
 	dh_auto_test --parallel
 	# Create build stamp
@@ -49,15 +51,15 @@
 	dh_compress -X.cc -X.h
 
 override_dh_install:
-	mkdir -vp ${CURDIR}/debian/libceres-dev/usr/lib/cmake/ceres ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal
+	mkdir -vp ${CURDIR}/debian/libceres-dev/usr/lib ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal
 	mv -v ${CURDIR}/debian/libceres.a ${CURDIR}/debian/libceres-dev/usr/lib/
 	mv -v ${CURDIR}/debian/config.h ${CURDIR}/debian/libceres-dev/usr/include/ceres/internal/
 	dh_install
 
 override_dh_installdocs:
 	# make lintian happy
-	# http://cdn.mathjax.org/mathjax/latest -> /usr/share/javascript/mathjax
-	sed -i 's/https:\/\/cdn.mathjax.org\/mathjax\/latest/\/usr\/share\/javascript\/mathjax/g' $(CURDIR)/debian/tmp/usr/share/doc/ceres/html/*.html
+	# https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0 -> /usr/share/javascript/mathjax
+	sed -i 's/https:\/\/cdnjs.cloudflare.com\/ajax\/libs\/mathjax\/2.7.0/\/usr\/share\/javascript\/mathjax/g' $(CURDIR)/debian/tmp/usr/share/doc/ceres/html/*.html
 	
 	# docs/html/_static/underscore.js	-> /usr/share/javascript/underscore/underscore.min.js
 	rm -f $(CURDIR)/debian/tmp/usr/share/doc/ceres/html/_static/underscore.js
